#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <multicolors>
#include <autoexecconfig>

#define DEBUG

#pragma semicolon 1

#pragma newdecls required

char g_ChatPrefix[256];
ConVar gConVar_Chat_Prefix;

ConVar gConVar_NoKnifeDamage_Join_Message;

public Plugin myinfo = 
{
	name = "No Knife Damage - Forever", 
	author = "LanteJoula", 
	description = "No Knife Damage - Forever", 
	version = "1.1", 
	url = "https://steamcommunity.com/id/lantejoula/"
};

public void OnPluginStart()
{
	//Translations
	LoadTranslations("noknifedamage-forever.phrases");
	
	//ConVars
	AutoExecConfig_SetFile("plugin.noknifedamage-forever");
	
	gConVar_Chat_Prefix = AutoExecConfig_CreateConVar("sm_noknifedamage_chat_prefix", "{green}[TAG]{default}", "Chat Prefix");
	
	gConVar_NoKnifeDamage_Join_Message = AutoExecConfig_CreateConVar("sm_noknifedamage_join_message", "1", "Enable/Disable the Message when Player Join (1 - Enable | 0 - Disable)", 0, true, 0.0, true, 1.0);
	
	
	AutoExecConfig_ExecuteFile();
	AutoExecConfig_CleanFile();
	
	gConVar_Chat_Prefix.AddChangeHook(OnPrefixChange);
	
	
	for (int client = 1; client <= MaxClients; client++)
	{
		if (IsClientInGame(client))
		{
			SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
		}
	}
}

//Prefix

public void SavePrefix()
{
	GetConVarString(gConVar_Chat_Prefix, g_ChatPrefix, sizeof(g_ChatPrefix));
}

public void OnConfigsExecuted()
{
	SavePrefix();
}

public void OnPrefixChange(ConVar cvar, char[] oldvalue, char[] newvalue)
{
	SavePrefix();
}

//PLUGIN

public void OnClientPutInServer(int client)
{
	SDKHook(client, SDKHook_OnTakeDamage, TakeDamageHook);
	
	CreateTimer(5.5, JoinMsgStaff, client);
}

public Action TakeDamageHook(int client, int &attacker, int &inflictor, float &damage, int &damagetype)
{
	if ((client >= 1) && (client <= MaxClients) && (attacker >= 1) && (attacker <= MaxClients) && (attacker == inflictor))
	{
		char WeaponName[64];
		GetClientWeapon(attacker, WeaponName, sizeof(WeaponName));
		if (StrContains(WeaponName, "knife", false) != -1 || StrEqual(WeaponName, "bayonet") || StrEqual(WeaponName, "melee") || StrEqual(WeaponName, "axe") || StrEqual(WeaponName, "hammer") || StrEqual(WeaponName, "spanner	") || StrEqual(WeaponName, "fists"))
		{
			damage = 0.0;
			return Plugin_Changed;
		}
	}
	return Plugin_Continue;
}

//JoinMsg

public Action JoinMsgStaff(Handle timer, any client)
{
	if (gConVar_NoKnifeDamage_Join_Message.BoolValue)
		CPrintToChat(client, "%s %t", g_ChatPrefix, "JoinMsg");
}
